@use "sass:math";

//=========================================================
//
//  ##        ###    ##    ##   #####   ##   ##  ######
//  ##       ## ##    ##  ##   ##   ##  ##   ##    ##
//  ##      ##   ##    ####    ##   ##  ##   ##    ##
//  ##      #######     ##     ##   ##  ##   ##    ##
//  ######  ##   ##     ##      #####    #####     ##
//
//=========================================================
body.step-outils {
  div.ReactModalPortal ~ div.ReactModalPortal {
    div.ReactModal__Content {
      box-shadow: none;
    }

    div.ReactModal__Overlay {
      background: transparent;
    }
  }
}

.modal__overlay,
div.ReactModal__Overlay {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  display: flex;
  z-index: 9000;
  justify-content: center;
  align-items: center;
  background: rgba(0, 0, 0, 0.6);

  @include phone() {
    display: block;
  }
}

.modal__container,
div.ReactModal__Content {
  background-color: #fff;
  padding: 4rem;
  min-width: 600px;
  width: 70vw;
  max-width: 900px;
  min-height: 35rem;
  max-height: 90vh;
  overflow-y: auto;
  box-sizing: border-box;
  box-shadow: 0px 10px 25px -10px rgba(#000, 0.5);
  display: flex;

  @media (max-height: 675px) {
    min-height: 25rem;
  }

  @include tablet() {
    width: 85%;
  }

  @include phone() {
    min-width: auto;
    // padding: 4rem 2rem 2rem 2rem;
    max-height: 100%;
    height: 100vh;
    width: 100vw;
  }

  div#diagnostic-create &,
  div#diagnostic-find-by-email &,
  div#user-request-workshop-attend &,
  div#user-request-workshop-organize &,
  div#user-request-osinum-contact & {
    width: 400px;

    @include phone() {
      width: 100%;
    }
  }
}

.modal__close {
  background: transparent;
  border: 0;
  position: absolute;
  top: 1.5rem;
  right: 1.5rem;
  z-index: 9000;
  cursor: pointer;
  outline: 0;
  color: #666;
  padding: 0;
  border: 1px solid #111;
  width: 40px;
  height: 40px;
  display: flex;
  align-items: center;
  justify-content: center;

  &:hover {
    color: #111;
  }

  svg {
    margin: 0;
    width: 18px;
    height: 18px;
    position: relative;
    top: 0px;
  }
}

.modal__header .modal__close:before {
  content: "\2715";
}

.modal__content {
  // margin-top: 2rem;
  // margin-bottom: 2rem;
  line-height: 1.5;
  color: rgba(0, 0, 0, 0.8);
}

div.modal-content-container {
  width: 100%;

  span.spinner {
    position: absolute;
    top: 50%;
    left: 50%;
    margin-left: -8px;
    margin-top: -8px;
  }

  div.modal-content {
    min-height: 250px;

    @include phone() {
      padding-bottom: 3rem;
    }
  }
}

div.modal {
  &.is-loading {
    div.modal-content-container {
      span.spinner {
        display: block;
      }

      div.modal-content {
        display: none;
      }
    }
  }

  &.loaded {
    div.modal-content-container {
      span.spinner {
        display: none;
      }

      div.modal-content {
        display: block;
      }
    }
  }
}

//========================================
//
//    ###    ##     ##  ##  ###    ###
//   ## ##   ####   ##  ##  ## #  # ##
//  ##   ##  ##  ## ##  ##  ##  ##  ##
//  #######  ##    ###  ##  ##      ##
//  ##   ##  ##     ##  ##  ##      ##
//
//========================================
@keyframes mmfadeIn {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

@keyframes mmfadeOut {
  from {
    opacity: 1;
  }
  to {
    opacity: 0;
  }
}

@keyframes mmslideIn {
  from {
    transform: translateY(15%);
  }
  to {
    transform: translateY(0);
  }
}

@keyframes mmslideOut {
  from {
    transform: translateY(0);
  }
  to {
    transform: translateY(-10%);
  }
}

.micromodal-slide {
  display: none;
}

.micromodal-slide.is-open {
  display: block;
}

.micromodal-slide[aria-hidden="false"] .modal__overlay {
  animation: mmfadeIn 0.3s cubic-bezier(0, 0, 0.2, 1);
}

.micromodal-slide[aria-hidden="false"] .modal__container {
  // animation: mmslideIn 0.3s cubic-bezier(0, 0, 0.2, 1);
}

.micromodal-slide[aria-hidden="true"] .modal__overlay {
  animation: mmfadeOut 0.3s cubic-bezier(0, 0, 0.2, 1);
}

.micromodal-slide[aria-hidden="true"] .modal__container {
  // animation: mmslideOut 0.3s cubic-bezier(0, 0, 0.2, 1);
}

.micromodal-slide .modal__container,
.micromodal-slide .modal__overlay {
  will-change: transform;
}

//=================================================================
//
//   ####   #####   ##     ##  ######  #####  ##     ##  ######
//  ##     ##   ##  ####   ##    ##    ##     ####   ##    ##
//  ##     ##   ##  ##  ## ##    ##    #####  ##  ## ##    ##
//  ##     ##   ##  ##    ###    ##    ##     ##    ###    ##
//   ####   #####   ##     ##    ##    #####  ##     ##    ##
//
//=================================================================
div.ReactModal__Content {
  padding: 0;
  position: relative;

  button.close-popup {
    position: absolute;
    top: 1.5rem;
    right: 1.5rem;
    padding: 0.65rem 0.7rem;

    svg {
      margin: 0;
      top: 0.05em;
    }
  }

  &#practice-popup,
  &#tool-popup {
    min-height: 42rem;
    overflow: hidden;

    @include phone() {
      min-height: 0;
      overflow: auto;
    }

    @media (max-height: 750px) {
      min-height: 35rem;
    }
  }

  &#tool-popup {
    button.close-popup {
      border-color: $bleu-1-dark;

      svg.icon {
        fill: $bleu-1-dark;
      }

      &:hover {
        background: $bleu-1-dark;
        color: $bleu-1;

        svg.icon {
          fill: $bleu-1;
        }
      }
    }
  }
}

.popup-container {
  display: grid;
  grid-template-columns: 40% 60%;
  width: 100%;

  @include phone() {
    display: block;
  }

  div.summary {
    padding: 3rem 2.5rem;
    display: flex;
    flex-direction: column;
    align-items: baseline;

    > div.icon {
      margin-top: auto;
    }

    p.number {
      display: flex;
      align-items: center;
      min-height: 40px;
      margin: 0;
      background: #fff;
      font-size: 0.75rem;
      padding: 0.5rem 1.175rem 0.5rem 2.5rem;
      border-radius: 2em;
      position: relative;

      svg.icon {
        position: absolute;
        left: 1.3em;
        top: 50%;
        transform: translateY(-50%);
        width: 1.4em;
        height: 1.4em;
        fill: #111;
      }
    }

    > h3 {
      margin: 1em 0 0.75em 0;
      font-size: 1.75rem;
      text-shadow: 0px 1px 0px rgba(#fff, 0.25);
    }

    > div.description {
      margin-top: 1rem;
      font-size: 0.875rem;
      max-height: 60vh;
      overflow: hidden;
      overflow-y: auto;
    }

    @include phone() {
      > div.icon {
        margin-top: 1.5rem;
      }
    }
  }

  div.body {
    padding: 7.5rem 5rem 3rem 2rem;
    display: flex;
    flex-direction: column;

    @media (max-height: 750px) {
      padding-top: 3.5rem;
    }

    @include phone() {
      padding: 3rem 2rem;
    }

    > footer {
      margin-top: auto;
      text-align: right;
    }

    div.inline-buttons {
      display: grid;
      grid-template-columns: 1fr 1fr;

      button {
        text-align: left;
        display: flex;
        flex-direction: row;

        svg {
          margin-left: auto;
        }
      }
    }
  }

  /**
   * Specifics
   */
  &.situation-popup-container {
    //
  }

  &.difficulty-popup-container,
  &.criteria-popup-container {
    div.summary {
      > h3 {
        text-shadow: 0px 1px 0px rgba(#000, 0.4);
      }
    }
  }

  &.practice-popup-container {
    div.tools-list {
      > p {
        font-size: 0.875rem;

        &:not(.fwn) {
          font-weight: bold;
        }
      }

      p.no-value {
        font-weight: normal;
        font-size: 0.6875rem;
        border-top: 1px solid #111;
        border-bottom: 1px solid #111;
        padding: 0.75em 0;
      }

      ul {
        list-style: none;
        padding: 1em 0;
        margin: 0;

        li {
          margin: 0;
          padding: 0;
          background: var(--bleu-1);
          font-size: 0.875rem;

          @include phone() {
            display: flex;
          }

          span {
            display: inline-block;
            padding: 0.75em;
            font-weight: bold;
            color: var(--bleu-1-dark);
          }

          button {
            border-color: var(--bleu-1);
            color: var(--bleu-1);
            margin-right: 0.5rem;
            border: none;
            margin: 0;
            height: 2.8em;
            width: 2.8em;

            &:first-of-type {
              margin-left: auto;
            }

            &:hover {
              background-color: var(--bleu-1-dark);

              svg {
                fill: var(--bleu-1);
              }
            }

            svg {
              fill: var(--bleu-1-dark);
              transform: scale(1.6);
              position: relative;
              top: -0.01em;
            }
          }

          + li {
            margin-top: 0.5em;
          }
        }
      }
    }

    div.add-tool-form-container {
      > button {
        width: 100%;
        text-align: left;
        display: flex;
        flex-direction: row;

        svg.icon {
          margin-left: auto;
        }
      }

      button.add-button {
        float: right;

        svg.icon {
          margin-left: 0.5em;
        }
      }

      div.input-container {
        input {
          padding-top: 0.675em;
          padding-bottom: 0.675em;
        }

        input.selected-tool-name {
          position: absolute;
          top: 1px;
          left: 1px;
          width: calc(100% - 2px);
          height: 2.3rem;
          background: #fff;
          border: none;
          z-index: 40;
        }
      }
    }
  }

  &.tool-popup-container {
    div.form-substep {
      margin-top: 1.25rem;
      padding-top: 1rem;
      border-top: 1px solid $gris;
    }

    ol.form-steps {
      list-style: none;
      margin: 0;
      padding: 0;
      padding-top: 1.5rem;
      margin-top: 1rem;
      border-top: 1px solid $gris;

      li {
        margin: 0;
        // color: var(--bleu-1-dark);
        padding-bottom: 0.75em;
        // border: 1px solid var(--bleu-1-dark);
        // font-size: 0.875em;

        + li {
          margin-top: 0.5em;
        }

        &.mini-title {
          padding: 0;
          border: none;
          font-size: 0.75em;
        }
      }
    }

    div.summary {
      ol.form-steps {
        margin-top: 2rem;
        padding-top: 0;
        border-top: none;
        width: 100%;

        li {
          border: 1px solid var(--bleu-1-dark);
          color: var(--bleu-1-dark);
          display: block;
          width: 100%;
          padding: 0.75em;
          font-size: 0.875em;

          &.active {
            background-color: var(--bleu-1-dark);
            color: var(--bleu-1);
            font-weight: normal;
          }
        }
      }
    }

    button {
      border: 1px solid var(--bleu-1-dark);
      color: var(--bleu-1-dark);

      svg {
        fill: var(--bleu-1-dark);
      }

      &:hover {
        background-color: var(--bleu-1-dark);
        color: var(--bleu-1);

        svg {
          fill: var(--bleu-1);
        }
      }
    }

    div.form-step {
      > h3 {
        color: $bleu-1-dark;
      }

      ol.practices {
        list-style: none;
        margin: 0;
        padding: 0;

        li {
          border: 1px solid var(--bleu-1-dark);
          color: var(--bleu-1-dark);
          display: inline-block;
          margin: 0 0.5rem 0.5rem 0;
          padding: 0.25em 0.5em;
          cursor: pointer;

          &.active,
          &:hover {
            border-color: var(--vert-1);
            background-color: var(--vert-1);
          }

          .icon {
            width: 1em;
            height: 1em;
            position: relative;
            top: 0.125em;
            margin-right: 0.125em;
          }
        }
      }

      ol.rating-buttons {
        display: flex;
        flex-direction: row;
        list-style: none;
        justify-content: space-between;
        margin: 0;
        padding: 0;

        li {
          flex-basis: 32%;
          text-align: center;
          padding: 0.325em 0;
          border: 1px solid var(--bleu-1-dark);
          color: var(--bleu-1-dark);

          svg.icon {
            fill: var(--bleu-1-dark);
          }

          &.selected {
            background-color: var(--bleu-1-dark);
            color: var(--bleu-1);

            svg.icon {
              fill: var(--bleu-1);
            }
          }

          label {
            cursor: pointer;

            input {
              opacity: 0;
              position: absolute;
              left: -9999px;

              &:checked {
                + span {
                  font-weight: bold;
                }
              }
            }

            svg.icon {
              height: 1.5rem;
              width: 1.5rem;
              position: relative;
              top: 0.225em;
            }

            span {
              display: block;
              font-size: 0.725rem;
              margin-top: 0.1em;
              position: relative;
            }
          }
        }
      }
    }
  }
}

h2.modal-title {
  margin-top: 0;
  color: $vert-1-dark;
  font-size: 1.75rem;
}

/**
 * Non-React modals.
 */
div.modal {
  /**
   * Permalink.
   */
  &#permalink {
    div.modal__container {
      min-height: auto;
      min-width: auto;
      width: 385px;
      padding-left: 1.5rem;
      padding-right: 1.5rem;
    }

    h2.modal-title {
      margin-top: 0.75em;
    }

    div.info-icon {
      position: absolute;
      top: 1.5rem;
      left: 1.5rem;

      svg.icon {
        width: 1.1rem;
        height: 1.1rem;
      }
    }
  }

  /**
   * Lead form.
   */
  &#diagnostic-lead-form {
    div.grid {
      column-gap: 3.5rem;
    }

    div.input {
      margin-bottom: 1.25rem;
    }

    label.checkbox {
      input {
        + span {
          font-weight: normal;
          padding-left: 5.5em;

          &:before,
          &:after {
            margin-top: 0.325em;
          }
        }
      }
    }
  }

  /**
   * Share
   */
  &#share,
  &#share-single-resource,
  &#share-single-tool {
    div.modal__container {
      min-height: auto;
    }

    ul.socials {
      display: flex;
      flex-direction: row;
      list-style: none;
      padding: 0;
      margin: 1rem 0 0 0;

      @include phone() {
        flex-wrap: wrap;
      }

      li {
        margin-right: 1rem;
        flex: 1;

        @include phone() {
          margin-bottom: 1rem;
        }

        a {
          display: block;
          display: flex;
          flex-direction: row;
          align-items: center;
          border-color: $bleu-1-dark;
          color: $bleu-1-dark;

          .icon {
            margin-left: auto;
            fill: $bleu-1-dark;
          }

          &:hover {
            background: $bleu-1-dark;
            color: $bleu-1;

            .icon {
              fill: $bleu-1;
            }
          }
        }
      }
    }
  }

  /**
   * Résultats Outils: criterias selection.
   */
  &#criterias-selection-popup {
    display: block;
    padding: 4rem;

    @include phone() {
      padding: 4rem 2rem 2rem 2rem;
    }

    div.criterias-groups {
      display: grid;
      grid-template-columns: repeat(3, 1fr);
      column-gap: 1.5rem;

      @include phone() {
        grid-template-columns: 1fr;
      }

      div.criterias-group {
        font-size: 0.875rem;

        @include phone() {
          + div.criterias-group {
            margin-top: 1rem;
          }
        }

        h6 {
          font-size: 0.875rem;
          margin: 0;
          font-weight: bold;
          padding: 0.375em 0.25em;
          border-bottom: 2px solid #111;
        }

        ol {
          margin: 1rem 0;
          padding: 0;
          list-style: none;

          li {
            display: block;

            button {
              width: 100%;
              text-align: left;
              border: none;
              display: block;

              &:hover {
                background: #ececec;
                color: #111;
              }
            }
          }
        }
      }
    }
  }

  /**
   * Résultats Outils: full table.
   */
  &#resultats-outil-tableau {
    div.modal__container {
      max-width: 100%;
      width: 90%;

      @include phone() {
        width: 100%;
      }
    }

    div.table-container {
      $cell1: 9rem;
      $cell23: 7rem;
      $cell4plus: 5rem;
      $min_width: calc(
        $cell1 + $cell23 + ($cell4plus * var(--criterias-count))
      );

      margin-top: 1.5rem;
      overflow-x: auto;
      padding-bottom: 1rem;

      table#outils-tableau {
        min-width: $min_width;

        @media print {
          min-width: auto;
        }

        th,
        td {
          &.type-usage {
            width: $cell23;

            @media print {
              width: auto;
            }
          }

          &.type-term {
            width: $cell4plus;

            @media print {
              width: auto;
            }
          }
        }

        tbody td.tool-name span.text {
          max-width: calc($cell1 - 1.5em);
        }
      }
    }

    footer.table-footer {
      p.legend {
        max-width: 15rem;

        color: #818181;
        font-size: 0.75rem;
        line-height: 1.4;
      }

      button.fr {
        @include phone() {
          float: none;
          display: block;
          width: 100%;
        }
      }
    }
  }
}

table#outils-tableau {
  margin: 0;
  font-size: 0.75rem;

  thead {
    font-size: 0.625rem;
    font-weight: normal;

    tr.headers-legend {
      text-align: left;

      th {
        font-weight: normal;
      }

      @media print {
        &,
        * {
          display: none !important;
        }
      }
    }

    tr.headers {
      th {
        height: 1px; // Hack for full-height span below.
        padding-top: 0;

        span {
          display: block;
          height: 100%;
          display: flex;
          align-items: center;
          justify-content: center;
          background: #ececec;
          font-weight: normal;
          padding: 0.5rem 0.325rem;

          @media print {
            padding-left: 0;
            padding-right: 0;
            background: transparent;
            display: block;
            text-align: left;
            font-size: 8px;
          }
        }

        @media print {
          height: auto;
          vertical-align: top;
        }

        &:first-of-type span {
          background: transparent;
        }
      }
    }
  }

  th,
  td {
    padding: 0.325rem 0.25rem;

    @media print {
      padding-left: 0;
      padding-right: 0;
    }

    &.type-usage,
    &.type-term {
      font-size: 0.625rem;

      @media print {
        font-size: 6px;
      }
    }
  }

  tbody {
    tr {
      td {
        border-top: 1px solid $gris;
      }

      @media print {
        print-color-adjust: exact !important;

        &:nth-child(odd) {
          background: #ede9e9;
        }
      }
    }

    td.tool-name {
      color: $bleu-1-dark;
      font-weight: bold;
      position: relative;
      padding-left: 1.5em;

      span.text {
        overflow: hidden;
        text-overflow: ellipsis;
        white-space: nowrap;
        display: block;
      }

      span.index {
        font-weight: normal;
        position: absolute;
        left: 0;
        top: 50%;
        margin-top: -0.6em;
      }
    }
  }
}
